pipeline {
    agent any

    environment {
        NEW_VERSION = '1.3.0';
        DOCKER_REGISTRY = 'docker.io' // Docker Hub registry
        DOCKER_IMAGE_NAME = 'amrou1991/go-app'
        DOCKER_IMAGE_TAG = "${DOCKER_IMAGE_NAME}:${NEW_VERSION}"

        SONARQUBE_URL = 'http://sonar:9000'  // Replace with your SonarQube server URL
        SONARQUBE_TOKEN = credentials('sonarqube-token')  // Use Jenkins credentials for SonarQube token
    }

    stages {
        
        stage('Build') {
            steps {
                echo 'building the application'
                echo "building version ${NEW_VERSION}"
            }
        }

        stage('Test') {
            steps {
                echo 'testing the application'
            }
        }

        stage("SonarQube analysis"){
            steps{
                withCredentials([string(credentialsId: 'sonarqube-token', variable: 'SONARQUBE_TOKEN')]) {
                    script {
                        // Run SonarQube analysis
                        sh "sonar-scanner -Dsonar.host.url=${SONARQUBE_URL} -Dsonar.login=${SONARQUBE_TOKEN}"
                    }
                }
            }
        }

        stage('Deploy') {
            steps {
                echo 'Deploying the application'

                // Authenticate with Docker Hub
                /*withCredentials([usernamePassword(credentialsId: 'dockerhub-credentials', passwordVariable: 'DOCKERHUB_PASSWORD', usernameVariable: 'DOCKERHUB_USERNAME')]) {
                    sh "docker login --username ${DOCKERHUB_USERNAME} --password ${DOCKERHUB_PASSWORD} ${DOCKER_REGISTRY}"
                }

                // Build and push Docker image
                sh "docker build -t ${DOCKER_IMAGE_TAG} ."
                sh "docker push ${DOCKER_IMAGE_TAG}" */

                // You can add additional deployment steps here
                // For example: sh 'kubectl apply -f k8s/deployment.yaml'
            }
        }
    }

    post {
        success {
            // This block is executed when the pipeline is successful
            echo 'Deployment successful!'
        }

        failure {
            // This block is executed when the pipeline fails
            echo 'Deployment failed.'
        }
    }

    /*
    when {
                expression {
                    BRANCH_NAME == 'prod' || BRANCH_NAME == 'main'
                }
            }
    */


}
